<?php
/*
	This helper file is where the directly contents are parsed.  The function takes as 
	parameters a path (the relative path to the images, and a string that represents the
	type of test that we want).  It will return an array of file names.  
	The $test variable makes this a versatile function that can be used to create directory 
	lists for different kinds of files.  To make this work, define other functions to 
	test different kinds of file types

*/
function dir_list(&$path, $test){ 
	// opens dir
	if ( !($dir_handle=@opendir($path)) ){ 
		trigger_error("Unable to open $path");
    	return null;
  	}
  	$theFiles = array();
  	// gets next file
  	while ($file = readdir($dir_handle)){  
 	 	// if passes test
 	 	//note that we're using a variable name to call a function!!
 	 	if ( $test($file) ){                   
     		array_push($theFiles, "$path/$file"); // puts on array
     	}
  	}
 	closedir($dir_handle);
  	sort($theFiles);  // sorts array
  	reset($theFiles);  
  	//return the sorted array of valid file names (with their path)   
  	return $theFiles;
}

function is_img($file){  
	return ( preg_match ("/\.jpg/", $file) || preg_match ("/\.png/", $file) );
}
?>
