<?php
/*
 this more complex demo, we open the file (created by filemanip.php), and read in its contents
 and then output them in a table.
 We also have fields to add a new entry which is written to the file
*/
$msg;
$err;
if(isset($_POST['submit'])){
   $first = $_POST['fname'];
   $last = $_POST['lname'];
   $birthplace = $_POST['bplace'];
   $type = $_POST['species'];
   $msg = "post was set";
   //make sure names aren't empty, and output an error if either is
   if(trim($first) === '' || trim($last) === ''){
      $msg .="nullname";
      $err = "first or last was empty";
   }else{
   	//if birthplace or species are empty, replace them with "unknown"
      $msg .= "names were good: $first $last, ";
      $line = array();
      //create an array, and put each of the four values in an element
      $line[0] = $first;
      $line[1] = $last;
      if(trim($birthplace)!==''){
         $line[2] = $birthplace;
      }else{
         $line[2] = "unknown";
      }
      if(trim($type) !==''){
         $line[3] = $type;
      }else{
         $line[3] = "unknown";
      }
      $c = count($line);
      $msg .= "number of elements: " . $c;
      $msg .= "calling addToContacts";
      //pass the array into function which should write to the file
      addToContacts($line);
      //$file = fopen("contacts.csv","a");
      
   }
}else{
   $msg = "post not set";
}
  // $list = array();
  // $list[0] = "Bender,Rodrigues,Mexico,Robot";
  // $list[1] = "Philip,Fry,Earth,Human";
  
function addToContacts($line){
   $msg .= ", in addToContacts with: ".$line;
   //open the file 
   //'a' means: Open for writing only; place the file pointer at the end of the file. 
   //If the file does not exist, attempt to create it. In this mode, fseek() has no effect, 
   //writes are always appended. 
   $file = fopen("contacts.csv","a");
   if($file){
      //put the line in using commas to separate the values
      fputcsv($file,$line);
      //close the file
      fclose($file);
   }
}

function getAllContacts(){
   $row = 0;
   //array will contain all the values from the file
   $list = array();
   $file = fopen("contacts.csv","r");
   if($file){
      while(($data = fgetcsv($file, 1000, ",")) !== FALSE){
      	//fgetcsv get each row of file, and put it in an array, using ',' as the separator
      	//https://secure.php.net/manual/en/function.fgetcsv.php
         $num = count($data);

 		//join the elements into a comma separated string
         $line = implode($data,",");
         //put this string in a list of strings at index $row
	 	$list[$row] = $line;
	 	$row++;
      }
      //close the file
      fclose($file);
   }
   return $list;
}
?>
<!DOCTYPE html>
<html>
<head><title>file stuff</title>
</head>
<body>
<h1>Reading in a Contacts file</h1>
<?php
   if(isset($err)){
      echo "<p>Houston, we had a problem</p>";
   }
   //if(isset($msg)){
   //   echo "<p>$msg</p>";
   //}
   $contacts = getAllContacts();
   $num = count($contacts);
   echo "<p>There are $num contacts in the file</p>";
   echo "<table>";
   echo "<tr><td>FirstName</td><td>LastName</td><td>BirthPlace</td><td>Species</td></tr>";
   foreach($contacts as $line){
      $contact = array();
      // use explode to convert the string to an array, using ',' as separator
      $contact = explode(",", $line);
 
      $numFields = count($contact);
      echo "<tr>";
      for($i=0; $i<4; $i++){
      	//output each column in a <td>
         echo "<td>$contact[$i]</td>";
      }
      echo "</tr>";
   }
   echo "</table>";
   
?>
<form method="post" action="filemanip.php">
<label for="fname">First Name: <input type="text" name="fname"></label>
<label for="lname">Last Name: <input type="text" name="lname"></label>
<label for="bplace">BirthPlace: <input type="text" name="bplace"></label>
<label for="species">Species: <input type="text" name="species"></label>
<input type="submit" value="Add" name="submit">
</form>
</body>
</html>
